# Sky map

### Exercise

Your task is to develop an app that utilizes GPS, accelerometer, and magnetometer data to determine the location and position of the device. The app should update an image at least 10 times per second for real-time updates.

Using the sensor data, you will send a request to a public API to retrieve information about celestial objects and display them on a black canvas within the app. When a user taps on an object, a short description of the object should be displayed.

To manage states within the app, you should use either the BLoC or Provider pattern. The objects to be displayed in the app include all planets of the solar system, the sun and moon, and three constellations of your choice.

The main objectives of this exercise are to work with hardware sensors, collect celestial objects using object-oriented programming (OOP) techniques, render objects in real-time, and work with APIs. The Provider pattern is available for reference in the documentation.

To complete this exercise, you will need to do the following:

1. Set up a development environment for the app.
2. Utilize the GPS, accelerometer, and magnetometer sensors to determine the location and position of the device.
3. Implement real-time updates by updating an image at least 10 times per second.
4. Send a request to a public API to retrieve information about celestial objects.
5. Display the celestial objects on a black canvas within the app.
6. Allow users to tap on an object to view a short description of it.
7. Use either the BLoC or Provider pattern to manage states within the app.
8. Test the app thoroughly to ensure that it is functioning correctly and all objectives have been met.

Remember to follow best practices for coding and app development, and be sure to document your code and any decisions made during the development process. Don't forget to consider user experience and design when creating the app, as a visually appealing and intuitive interface will be important for its success. Good luck!

Possible examples of the app:

<center>

<img src="./resources/skyMap.01.jpg?raw=true" style = "width: 840px !important; height: 420px !important;"/>

</center>

<center>

<img src="./resources/skyMap.02.png?raw=true" style = "width: 840px !important; height: 420px !important;"/>
</center>
